unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, OleCtrls, WMPLib_TLB, StdCtrls, Grids, ComCtrls, ExtCtrls, unit2, unit3;

type tido=record
       hour:string[2];
       min:string[2];
       sec:string[2];
       msec:string[3];
       end;

     PTablazatelem=^TTablazatelem;

     Ttablazatelem=record
        kido:tido;
        vido:tido;
        kezdet,veg:double;
        szoveg:string;
        szoveg2:string;
        end;

type
  TForm1 = class(TForm)
    WindowsMediaPlayer1: TWindowsMediaPlayer;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Openvidoe1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button2: TButton;
    StringGrid1: TStringGrid;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Edit4: TEdit;
    Opensubfile1: TMenuItem;
    SaveSubfile1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Edit5: TMenuItem;
    Hozzfz1: TMenuItem;
    Eltol1: TMenuItem;
    procedure kiir(s:string);
    procedure Openvidoe1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure SaveSubfile1Click(Sender: TObject);
    procedure Opensubfile1Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure ThreadTerminate(Sender: TObject);
    procedure CreateThread;
    procedure Hozzfz1Click(Sender: TObject);
    procedure Eltol1Click(Sender: TObject);

  private
  Thread1:Mediafigyel;
    { Private declarations }
  public
    { Public declarations }
  end;

  function mptoora(be:double):TIdo;
  procedure listarendezes(var lista:TList);
//  function tidotomp(t:tido):double;

var
  Form1: TForm1;
  tablazate:Ttablazatelem;
  lista:TList;
  megye:boolean;
  letelista:boolean;
  ts1,ts2,ts3,ts4:string;
  hozzaad:boolean;

implementation

{$R *.DFM}

procedure listarendezes(var lista:tlist);
var i,j:integer;
e,e1,e3:Ptablazatelem;
begin
for i:=0 to lista.count-2 do
        begin
        for j:=i+1 to lista.count-1 do
                begin
                e:=lista.items[i];
                e1:=lista.Items[j];
                if e.kezdet>e1.kezdet then
                        begin
                        e3:=e;
                        e:=e1;
                        e1:=e3;
                        lista.Items[i]:=e;
                        lista.Items[j]:=e1;
                        end;
                end;
        end;
end;

function mptoora(be:double):TIdo;
var t:tido;
var i:integer;
begin
i:=round(be-0.49);
t.hour:=inttostr(i div 3600);
i:=i-(strtoint(t.hour))*3600;
t.min:=inttostr(i div 60);
i:=i-strtoint(t.min)*60;
t.sec:=inttostr(i);
t.msec:=inttostr(round(1000*(be-round(be-0.49))));
if strtoint(t.hour)<10 then t.hour:='0'+t.hour;
if strtoint(t.min)<10 then t.min:='0'+t.min;
if strtoint(t.sec)<10 then t.sec:='0'+t.sec;
if strtoint(t.msec)<10 then t.msec:='00'+t.msec else if strtoint(t.msec)<100 then t.msec:='00'+t.msec;
mptoora:=t;
end;

function tidotomp(t:tido):double;
var i:double;
begin
i:=strtoint(t.hour)*3600;
i:=i+strtoint(t.min)*60;
i:=i+strtoint(t.sec);
i:=i+(strtoint(t.msec)/1000);
tidotomp:=i;
end;

procedure TForm1.Openvidoe1Click(Sender: TObject);
var s:string;
begin
opendialog1.Execute;
s:=opendialog1.filename;
windowsmediaplayer1.URL:=s;
if s<>'' then
        begin
        megye:=true;
        CreateThread;
        end else megye:=false;
end;

procedure Tform1.CreateThread;
begin
if Thread1 <> nil then
   Thread1.Free;
  Thread1 := Mediafigyel.Create(True);
  Thread1.FreeOnTerminate := False;
  Thread1.OnTerminate := ThreadTerminate;
  Thread1.Resume;
end;

procedure TForm1.ThreadTerminate(Sender: TObject);
begin
if megye then CreateThread;
end;


procedure TForm1.Button1Click(Sender: TObject);
var i:double;
t:tido;
begin
i:=windowsmediaplayer1.controls.Get_currentPosition;
t:=mptoora(i);
edit2.text:=t.hour+':'+t.min+':'+t.sec+':'+t.msec;
tablazate.kido:=t;
tablazate.kezdet:=i;
end;


procedure TForm1.Exit1Click(Sender: TObject);
begin
megye:=false;
windowsmediaplayer1.controls.stop;
close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
letelista:=false;
panel1.Visible:=false;
panel2.visible:=false;
stringgrid1.Cells[0,0]:='Start Time';
stringgrid1.cells[1,0]:='Finish Time';
Stringgrid1.cells[2,0]:='Text';
stringgrid1.cells[3,0]:='Text2';
lista:=Tlist.create;
windowsmediaplayer1.settings.Set_volume(100);
megye:=false;
end;

procedure TForm1.Button2Click(Sender: TObject);
var i:double;
t:tido;
begin
i:=windowsmediaplayer1.controls.Get_currentPosition;
t:=mptoora(i);
edit3.text:=t.hour+':'+t.min+':'+t.sec+':'+t.msec;
tablazate.vido:=t;
tablazate.veg:=i;
end;

procedure TForm1.Button3Click(Sender: TObject);
var elem:Ptablazatelem;
i:integer;
t:tido;
hiba:boolean;
begin
t.hour:=edit2.text[1]+edit2.text[2];
t.min:=edit2.text[4]+edit2.text[5];
t.sec:=edit2.text[7]+edit2.text[8];
t.msec:=edit2.text[10]+edit2.text[11]+edit2.text[12];
tablazate.kido:=t;
t.hour:=edit3.text[1]+edit3.text[2];
t.min:=edit3.text[4]+edit3.text[5];
t.sec:=edit3.text[7]+edit3.text[8];
t.msec:=edit3.text[10]+edit3.text[11]+edit2.text[12];
tablazate.vido:=t;
tablazate.kezdet:=tidotomp(tablazate.kido);
tablazate.veg:=tidotomp(tablazate.vido);
hiba:=false;
if tablazate.kezdet<tablazate.veg then
  begin
  tablazate.szoveg:=edit1.text;
  tablazate.szoveg2:=edit4.text;
  i:=0;
  if lista.count>0 then
    begin
    elem:=lista.first;

     while (i<=lista.count-2) and (tablazate.kezdet>elem^.veg) do
        begin
        i:=i+1;
        elem:=lista.Items[i];
        end;

   if tablazate.kezdet>elem^.kezdet then i:=i+1;

    if (elem^.kezdet>=tablazate.veg) or (lista.count=i) then
                begin
                hiba:=true;
                new(elem);
                elem^:=tablazate;
                lista.Insert(i,elem);
                end else showmessage('Error: The time intervall is not correct! The intervall is in other intervall!');
    end else
        begin
        new(elem);
        hiba:=true;
        elem^:=tablazate;
        lista.add(elem);
        end;

if hiba then
  begin
  if lista.count>3 then stringgrid1.RowCount:=stringgrid1.RowCount+1;
  for i:=0 to lista.count-1 do
        begin
        with stringgrid1 do
                begin
                elem:=lista.items[i];
                cells[0,i+1]:=elem^.kido.hour+':'+elem^.kido.min+':'+elem^.kido.sec+':'+elem^.kido.msec;
                cells[2,i+1]:=elem^.szoveg;
                cells[3,i+1]:=elem^.szoveg2;
                cells[1,i+1]:=elem^.vido.hour+':'+elem^.vido.min+':'+elem^.vido.sec+':'+elem^.vido.msec;
                end;
        end;
   end;
  end else showmessage('Error: The intervall not correct! The start time smaller then finish time!');
end;

procedure TForm1.Button4Click(Sender: TObject);
var s:string;
begin
//clickedok:=inputquery('New Positon','Please enter the new position in seconds:',s);
s:= InputBox('New Position', 'Please enter the new position:', floattostr(windowsmediaplayer1.controls.Get_currentPosition));
if s<>'' then
        begin
        try
        windowsmediaplayer1.controls.Set_currentPosition(strtofloat(s));
        except showmessage('Can not position to there!');
        end;
        end;
end;

procedure TForm1.Button5Click(Sender: TObject);
var myRect: TGridRect;
i:integer;
elem:ptablazatelem;
begin
myrect:=Stringgrid1.Selection;
if myrect.Top=myrect.bottom then
        begin
        case messagedlg('Are you sure to delete this?',mtconfirmation,[mbyes,mbno],0) of
             mryes:
                begin
                i:=myrect.bottom-1;
                if lista.count>0 then
                        begin
                        lista.Delete(i);
                        end;
                  for i:=0 to lista.count-1 do
                        begin
                         with stringgrid1 do
                                begin
                                elem:=lista.items[i];
                                cells[0,i+1]:=elem^.kido.hour+':'+elem^.kido.min+':'+elem^.kido.sec+':'+elem^.kido.msec;
                                cells[2,i+1]:=elem^.szoveg;
                                cells[3,i+1]:=elem^.szoveg2;
                                cells[1,i+1]:=elem^.vido.hour+':'+elem^.vido.min+':'+elem^.vido.sec+':'+elem^.vido.msec;
                                end;
                        end;
                stringgrid1.cells[0,i+1]:='';
                stringgrid1.cells[2,i+1]:='';
                stringgrid1.cells[3,i+1]:='';
                stringgrid1.cells[1,i+1]:='';
                if lista.count>3 then stringgrid1.rowcount:=StringGrid1.rowcount-1;
                end;
             end;
        end
        else showmessage('Plesae choose just 1 rows!');
end;

procedure TForm1.Button6Click(Sender: TObject);
var myRect: TGridRect;
e:Ptablazatelem;
begin
myrect:=stringgrid1.Selection;
e:=lista.Items[myrect.bottom-1];
edit2.text:=e^.kido.hour+':'+e^.kido.min+':'+e^.kido.sec+':'+e^.kido.msec;
edit3.text:=e^.vido.hour+':'+e^.vido.min+':'+e^.vido.sec+':'+e^.vido.msec;
edit1.text:=e^.szoveg;
edit4.text:=e^.szoveg2;
windowsmediaplayer1.controls.Set_currentPosition(e^.kezdet);
end;

procedure Tform1.kiir(s:string);
var sv:string;
e:ptablazatelem;
i:integer;
begin
Assignfile(output,s);
ReWrite(output);
for i:=0 to lista.count-1 do
        begin
        e:=lista.Items[i];
        writeln(output,inttostr(i+1));
        sv:=e^.kido.hour+':'+e^.kido.min+':'+e^.kido.sec+':'+e^.kido.msec;
        sv:=sv+' --> ';
        sv:=sv+e^.vido.hour+':'+e^.vido.min+':'+e^.vido.sec+':'+e^.vido.msec;
        writeln(output,sv);
        writeln(output,e^.szoveg);
        if e^.szoveg2<>'' then writeln(output,e^.szoveg2);
        writeln(output);
        end;
closefile(output);
end;

procedure TForm1.SaveSubfile1Click(Sender: TObject);
var s:string;
begin
s:='';
savedialog1.execute;
s:=savedialog1.filename;
if s<>'' then
        begin
        {$i-}
        Assignfile(output,s);
        reset(output);
        {$i+}
        if ioresult=0 then
                begin
                case messagedlg('Would you like to overwrite it?',mtconfirmation,[mbyes,mbno],0) of
                     mryes:  begin
                             closefile(output);
                             kiir(s);
                             end;
                        end;
                end else kiir(s);

        //closefile(output);
        end;
end;

procedure TForm1.Opensubfile1Click(Sender: TObject);
var i,j:integer;
s:string;
e:ptablazatelem;
hiba:boolean;
begin
s:='';
edit1.text:='';
edit2.text:='';
edit3.text:='';
edit4.text:='';
lista.Destroy;
lista:=tlist.Create;
letelista:=true;
stringgrid1.RowCount:=5;
for i:=1 to 4 do
        begin
        for j:=1 to 4 do
                begin
                stringgrid1.Cells[i,j]:='';
                end;
        end;
opendialog1.execute;
s:=opendialog1.FileName;
if s<>'' then
        begin
        Assignfile(input,s);
        reset(input);
        i:=1;
        readln(s);
        while not(eof(input)) do
                begin
                if inttostr(i)=s then
                        begin
                        i:=i+1;
                        readln(s);
                        new(e);
                        e^.kido.hour:=s[1]+s[2];
                        e^.kido.min:=s[4]+s[5];
                        e^.kido.sec:=s[7]+s[8];
                        e^.kido.msec:=s[10]+s[11]+s[12];
                        e^.vido.hour:=s[18]+s[19];
                        e^.vido.min:=s[21]+s[22];
                        e^.vido.sec:=s[24]+s[25];
                        e^.vido.msec:=s[27]+s[28]+s[29];

                        e^.kezdet:=tidotomp(e^.kido);
                        e^.veg:=tidotomp(e^.vido);
                        readln(s);
                        e^.szoveg:=s;
                        readln(s);
                        if inttostr(i)=s then hiba:=true else e^.szoveg2:=s;
                        lista.Add(e);
                        end;
                if not(hiba) then readln(s) else hiba:=false;
                end;
        closefile(input);
        end;

//        if lista.count>3 then stringgrid1.RowCount:=stringgrid1.RowCount+1;
        for i:=0 to lista.count-1 do
           begin
           with stringgrid1 do
                begin
                if i>3 then stringgrid1.RowCount:=stringgrid1.RowCount+1;
                e:=lista.items[i];
                cells[0,i+1]:=e^.kido.hour+':'+e^.kido.min+':'+e^.kido.sec+':'+e^.kido.msec;
                cells[2,i+1]:=e^.szoveg;
                cells[3,i+1]:=e^.szoveg2;
                cells[1,i+1]:=e^.vido.hour+':'+e^.vido.min+':'+e^.vido.sec+':'+e^.vido.msec;
                end;
           end;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
windowsmediaplayer1.controls.Set_currentPosition(windowsmediaplayer1.controls.Get_currentPosition-60);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
windowsmediaplayer1.controls.Set_currentPosition(windowsmediaplayer1.controls.Get_currentPosition-10);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
windowsmediaplayer1.controls.Set_currentPosition(windowsmediaplayer1.controls.Get_currentPosition-1);
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
windowsmediaplayer1.controls.Set_currentPosition(windowsmediaplayer1.controls.Get_currentPosition+1);
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
windowsmediaplayer1.controls.Set_currentPosition(windowsmediaplayer1.controls.Get_currentPosition+10);
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
windowsmediaplayer1.controls.Set_currentPosition(windowsmediaplayer1.controls.Get_currentPosition+60);
end;

procedure TForm1.Hozzfz1Click(Sender: TObject);
var s:string;
    hiba,hiba2:boolean;
    e:PTablazatelem;
    i:integer;
    tablaveg:double;
begin
if letelista then
   begin
   opendialog1.execute;
   s:=opendialog1.filename;
   if s<>'' then
      begin
      {Megnyitjuk a fuzni kivant filet}
      Assignfile(input,s);
      reset(input);
      hiba:=false;
      {beolvassuk az elso elemet}
      readln(input,s);
      i:=strtoint(s);
      e:=lista.last;
      tablaveg:=e^.veg;
      while (not(hiba)) and (not(eof(input))) do
          begin
          if inttostr(i)=s then
             begin
             i:=i+1;
             {olvassuk az elemet.}
             readln(s);
             {lefoglaljuk az uj elem helyet a memoriaban}
             new(e);
             {kiolvassuk az elemeket a memoriaba}
             e^.kido.hour:=s[1]+s[2];
             e^.kido.min:=s[4]+s[5];
             e^.kido.sec:=s[7]+s[8];
             e^.kido.msec:=s[10]+s[11]+s[12];
             e^.vido.hour:=s[18]+s[19];
             e^.vido.min:=s[21]+s[22];
             e^.vido.sec:=s[24]+s[25];
             e^.vido.msec:=s[27]+s[28]+s[29];

             e^.kezdet:=tidotomp(e^.kido);
             e^.veg:=tidotomp(e^.vido);
             readln(s);
             e^.szoveg:=s;
             readln(s);

             {Ha a kovetkezo olvasas szam, akkor nem kell meg egyet olvasni.
             Ha szoveg akkor be kell tenni a listba es meg egyet olvasni.}

             if inttostr(i)=s then hiba2:=true else e^.szoveg2:=s;
             if not(hiba2) then readln(s) else hiba2:=false;

             {A listahoz csak akkor adunk hozza, ha az idok stimelnek, tehat az
             uj file elso eleme, tenyleg a mi listank utolso eleme utan jon.}
             if tablaveg<e^.kezdet then lista.Add(e) else
                                begin
                                hiba:=true;
                                showmessage('Error: The new time smaller than the old time!');
                                end;
             end else readln(s);
          //hiba:=true;
          end;
      closefile(input);
      form1.stringgrid1.RowCount:=5;
      for i:=0 to lista.count-1 do
          begin
          with form1.stringgrid1 do
                begin
                if i>3 then form1.stringgrid1.RowCount:=form1.stringgrid1.RowCount+1;
                e:=lista.items[i];
                cells[0,i+1]:=e^.kido.hour+':'+e^.kido.min+':'+e^.kido.sec+':'+e^.kido.msec;
                cells[2,i+1]:=e^.szoveg;
                cells[3,i+1]:=e^.szoveg2;
                cells[1,i+1]:=e^.vido.hour+':'+e^.vido.min+':'+e^.vido.sec+':'+e^.vido.msec;
                end;
          end;
      end;
   end else showmessage('Please open a subtitle');
end;

procedure feldolgoz;
var s,s2:string;
    i:integer;
    t1,t2,t3,t4:TTime;
    hour,min,sec,msec:word;
    shour,smin,ssec,smsec:string;
    e:Ptablazatelem;
    ido:TIdo;
    eltolasdoub:double;
begin

{T3 lesz az eltolasido. }
t3:=encodetime(strtoint(ts1),strtoint(ts2),strtoint(ts3),strtoint(ts4));
for i:=0 to lista.count-1 do
        begin
        e:=lista.Items[i];
        {A kezdeti idot beteszam hour,min,sec,msecbe amik
        szoveg tipusuak.}
        hour:=strtoint(e^.kido.hour);
        min:=strtoint(e^.kido.min);
        sec:=strtoint(e^.kido.sec);
        msec:=strtoint(e^.kido.msec);
        {t1 lesz a kezdeti ido}
        t1:=encodetime(hour,min,sec,msec);
        hour:=strtoint(e^.vido.hour);
        min:=strtoint(e^.vido.min);
        sec:=strtoint(e^.vido.sec);
        msec:=strtoint(e^.vido.msec);
        {t2 lesz a veg ido}
        t2:=encodetime(hour,min,sec,msec);
        {ido az eltolasnak a tido tipusa.}
        ido.hour:=ts1;
        ido.min:=ts2;
        ido.sec:=ts3;
        ido.msec:=ts4;
        {eltolasdoub az eltolasnak a double tipusa}
        eltolasdoub:=tidotomp(ido);
        {Ezutan megcsinaljuk az eltolast. El kell
        tolni az idot is meg a duble tipust is.

        Eloszor a kezdet idovel kezdjuk, majd
        kiirjuk a listaba.}
        if hozzaad then t4:=t1+t3 else t4:=t1-t3;
        if hozzaad then e^.kezdet:=eltolasdoub+e^.kezdet else e^.kezdet:=e^.kezdet-eltolasdoub;
        decodetime(t4,hour,min,sec,msec);
        if hour<10 then shour:='0'+inttostr(hour) else shour:=inttostr(hour);
        if min<10 then smin:='0'+inttostr(min) else smin:=inttostr(min);
        if sec<10 then ssec:='0'+inttostr(sec) else ssec:=inttostr(sec);
        if msec<10 then smsec:='00'+inttostr(msec) else if msec<100 then smsec:='0'+inttostr(msec) else smsec:=inttostr(msec);
        //s2:=shour+':'+smin+':'+ssec+':'+smsec+' --> ';
        e^.kido.hour:=shour;
        e^.kido.min:=smin;
        e^.kido.sec:=ssec;
        e^.kido.msec:=smsec;

        {Ezutan eltoljuk a vegidot is. }
        if hozzaad then t4:=t2+t3 else t4:=t2-t3;
        if hozzaad then e^.veg:=eltolasdoub+e^.veg else e^.veg:=e^.veg-eltolasdoub;
        decodetime(t4,hour,min,sec,msec);
        if hour<10 then shour:='0'+inttostr(hour) else shour:=inttostr(hour);
        if min<10 then smin:='0'+inttostr(min) else smin:=inttostr(min);
        if sec<10 then ssec:='0'+inttostr(sec) else ssec:=inttostr(sec);
        if msec<10 then smsec:='00'+inttostr(msec) else if msec<100 then smsec:='0'+inttostr(msec) else smsec:=inttostr(msec);
        e^.vido.hour:=shour;
        e^.vido.min:=smin;
        e^.vido.sec:=ssec;
        e^.vido.msec:=smsec;
        end;
   form1.stringgrid1.RowCount:=5;
   for i:=0 to lista.count-1 do
    begin
     with form1.stringgrid1 do
        begin
        if i>3 then form1.stringgrid1.RowCount:=form1.stringgrid1.RowCount+1;
        e:=lista.items[i];
        cells[0,i+1]:=e^.kido.hour+':'+e^.kido.min+':'+e^.kido.sec+':'+e^.kido.msec;
        cells[2,i+1]:=e^.szoveg;
        cells[3,i+1]:=e^.szoveg2;
        cells[1,i+1]:=e^.vido.hour+':'+e^.vido.min+':'+e^.vido.sec+':'+e^.vido.msec;
        end;
    end;
 end;

procedure TForm1.Eltol1Click(Sender: TObject);
var i:integer;
s:string;
begin
if letelista then
   begin
   form3.ShowModal;
   feldolgoz;
   end else showmessage('Please open a subtitle before!');
end;

end.
